.build:
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  stage: build
  before_script:
    - echo "$MICRO_SERVICE"
    - apk update && apk add --no-cache curl
    - curl -sSLo /usr/local/bin/yq https://github.com/mikefarah/yq/releases/download/v4.40.5/yq_linux_amd64
    - chmod +x /usr/local/bin/yq
    - cd $MICRO_SERVICE
    - PREV_VERSION=$(yq -oy '.version' ./package.json)
    - NEW_VERSION=$(echo "$PREV_VERSION" | awk -F. '{print $1 "." $2 "." $3+1}')
    - yq -oj ".version = \"$NEW_VERSION\"" package.json -i
    - export IMAGE_NAME=$CI_REGISTRY_IMAGE/$MICRO_SERVICE
    - export IMAGE_TAG=$NEW_VERSION
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY 


  
  script:
    - docker build -t $CI_REGISTRY_IMAGE/$MICRO_SERVICE:$IMAGE_TAG .
    - echo "image build successfully"
    - docker push $CI_REGISTRY_IMAGE/$MICRO_SERVICE:$IMAGE_TAG
